Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.aop.joinpoint
Class MethodCalledByMethodInvocation

    java.lang.Object
      org.jboss.aop.joinpoint.InvocationBase
          org.jboss.aop.joinpoint.CallerInvocation
              org.jboss.aop.joinpoint.MethodCalledByMethodInvocation

All Implemented Interfaces:
  Invocation, Serializable

Direct Known Subclasses:
  MethodCalledByMethodInvocationWrapper

public class MethodCalledByMethodInvocation
extends CallerInvocation

This is a helper wrapper class for an Invocation object. It is used to add or get values or metadata that pertains to an AOP method invocation.

Version:
  $Revision: 1.18 $
Author:
  Bill Burke
See Also:
  Serialized Form

Field Summary
`protected Object[]` | `arguments`
`protected Object` | `callingObject`

Fields inherited from class org.jboss.aop.joinpoint.InvocationBase
`advisor, currentInterceptor, instanceResolver, interceptors, metadata, responseContextInfo, targetObject`

Constructor Summary
`MethodCalledByMethodInvocation(Advisor advisor, Class callingClass, Method callingMethod, Method method, Object callingObject, Object targetObject, Object[] args, Interceptor[] interceptors)`
`MethodCalledByMethodInvocation(Interceptor[] interceptors)`
`MethodCalledByMethodInvocation(MethodByMethodInfo info, Object callingObject, Object targetObject, Interceptor[] interceptors)`
`MethodCalledByMethodInvocation(MethodByMethodInfo info, Object callingObject, Object targetObject, Object[] arguments, Interceptor[] interceptors)`

Method Summary
`Invocation` | `copy()` Copies complete state of Invocation object.
`Object[]` | `getArguments()`
`Method` | `getCalledMethod()`
`Class` | `getCallingClass()`
`Method` | `getCallingMethod()`
`Object` | `getCallingObject()`
`Object` | `getMetaData(Object group, Object attr)` This method resolves metadata based on the context of the invocation.
`Invocation` | `getWrapper(Interceptor[] newchain)` Get a wrapper invocation object that can insert a new chain of interceptors at runtime to the invocation flow.
`Object` | `invokeNext()` Invoke on the next interceptor in the chain.
`void` | `setArguments(Object[] arguments)` change the arguments to the called method

Methods inherited from class org.jboss.aop.joinpoint.InvocationBase
`addResponseAttachment, getAdvisor, getCurrentInterceptor, getInstanceResolver, getInterceptors, getMetaData, getResponseAttachment, getResponseContextInfo, getTargetObject, invokeNext, resolveAnnotation, resolveAnnotation, resolveClassAnnotation, resolveClassMetaData, setAdvisor, setInstanceResolver, setMetaData, setResponseContextInfo, setTargetObject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### arguments

    protected Object[] arguments

### callingObject

    protected Object callingObject

Constructor Detail

### MethodCalledByMethodInvocation

    public MethodCalledByMethodInvocation(MethodByMethodInfo info,
                                          Object callingObject,
                                          Object targetObject,
                                          Object[] arguments,
                                          Interceptor[] interceptors)

### MethodCalledByMethodInvocation

    public MethodCalledByMethodInvocation(MethodByMethodInfo info,
                                          Object callingObject,
                                          Object targetObject,
                                          Interceptor[] interceptors)

### MethodCalledByMethodInvocation

    public MethodCalledByMethodInvocation(Advisor advisor,
                                          Class callingClass,
                                          Method callingMethod,
                                          Method method,
                                          Object callingObject,
                                          Object targetObject,
                                          Object[] args,
                                          Interceptor[] interceptors)

### MethodCalledByMethodInvocation

    public MethodCalledByMethodInvocation(Interceptor[] interceptors)

Method Detail

### invokeNext

    public Object invokeNext()
                      throws Throwable

  Invoke on the next interceptor in the chain. If this is already the end of the chain, reflection will call the constructor, field, or method you are invoking on.

  Specified by:
    `invokeNext` in interface `Invocation`
  Overrides:
    `invokeNext` in class `InvocationBase`
  Throws:
    `Throwable`

### getMetaData

    public Object getMetaData(Object group,
                              Object attr)

  This method resolves metadata based on the context of the invocation. It iterates through its list of MetaDataResolvers to find out the value of the metadata desired.

  This list usually is ThreadMetaData, InstanceAdvisor.getMetaData ClassAdvisor.getMethodMetaData (or field, or constructor) ClassAdvisor.getDefaultMetaData

  Specified by:
    `getMetaData` in interface `Invocation`
  Overrides:
    `getMetaData` in class `InvocationBase`

### getWrapper

    public Invocation getWrapper(Interceptor[] newchain)

  Get a wrapper invocation object that can insert a new chain of interceptors at runtime to the invocation flow. CFlow makes use of this. When the wrapper object finishes its invocation chain it delegates back to the wrapped invocation.

  Parameters:
    `newchain` -
  Returns:

### copy

    public Invocation copy()

  Copies complete state of Invocation object.

  Returns:

### getArguments

    public Object[] getArguments()

  Returns:
    the arguments of the called method

### setArguments

    public void setArguments(Object[] arguments)

  change the arguments to the called method

  Parameters:
    `arguments` -

### getCallingClass

    public Class getCallingClass()

  Returns:
    The class that is making the call on the method

### getCallingMethod

    public Method getCallingMethod()

  Returns:
    The method that is making the call on the method

### getCalledMethod

    public Method getCalledMethod()

### getCallingObject

    public Object getCallingObject()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 JBoss Inc. All Rights Reserved.